#!/bin/bash

# QUI NON SERVE, attenzione che questo e' stato adattato rispetto a quello che ho in locale
#wget --quiet --mirror -np http://arcipelagoareac.it/CSV/
#wget --quiet --mirror -np http://arcipelagoareac.it/Grafici/


################################################################
dati(){
#echo se.data, se.pm10, li.data, li.pm10, diff, se.pm25, li.pm25
sqlite3 << HERE

create table limito (data date, so2 integer, pm10 integer, pm25 integer, no2 integer, co integer, o3 integer, benzene integer);
.mode csv
.import ./CSV/LimitodiPioltello.csv limito
--select data,pm10 from limito where data >= '2014-01-01 00:00:00';

create table senato (data date, so2 integer, pm10 integer, pm25 integer, no2 integer, co integer, o3 integer, benzene integer);
.mode csv
.import ./CSV/MilanoSenato.csv senato
--select data,pm10 from senato where data >= '2014-01-01 00:00:00';

select se.data, se.pm10, li.data, li.pm10, se.pm10-li.pm10 as 'PM10diff',se.pm25,li.pm25 from senato se join limito li using (data);
-- where data >= '2008/04/20';

HERE
#|grep -v nd
#.separator ","
}

################################################################
altri(){
#echo Anno\(senato\),SO2,PM10,PM2.5,NO2,CO,O3,Benzene
#echo $1
sqlite3 << HERE

create table senato   (data date, so2 integer, pm10 integer, pm25 integer, no2 integer, co integer, o3 integer, benzene integer);
.mode csv
.import ./CSV/MilanoSenato.csv senato

--create table verziere (data date, so2 integer, pm10 integer, pm25 integer, no2 integer, co integer, o3 integer, benzene integer);
--.mode csv
--.import ./CSV/MilanoVerziere.csv verziere

--select avg(so2) from senato where data >= '$1/01/01' and data <= '$1/12/31' and so2 <> " " and so2 <> "nd";
select avg(pm10) from senato where data >= '$1/01/01' and data <= '$1/12/31' and pm10 <> " " and pm10 <> "nd";
select avg(pm25) from senato where data >= '$1/01/01' and data <= '$1/12/31' and pm25 <> " " and pm25 <> "nd";
select avg(no2) from senato where data >= '$1/01/01' and data <= '$1/12/31' and no2 <> " " and no2 <> "nd";
select avg(co) from senato where data >= '$1/01/01' and data <= '$1/12/31' and co <> " " and co <> "nd";
select avg(o3) from senato where data >= '$1/01/01' and data <= '$1/12/31' and o3 <> " "  and o3 <> "nd";
select avg(benzene) from senato where data >= '$1/01/01' and data <= '$1/12/31' and benzene <> " " and benzene <> "nd";

--select * from senato where data >= '$1/01/01' and data <= '$1/12/31';

HERE
#|grep -v nd
#.separator ","
}

################################################################
prove(){
#echo Anno\(senato\),SO2,PM10,PM2.5,NO2,CO,O3,Benzene
echo $1
sqlite3 << HERE

create table senato   (data date, so2 integer, pm10 integer, pm25 integer, no2 integer, co integer, o3 integer, benzene integer);
.mode csv
.import ./CSV/MilanoSenato.csv senato

--create table verziere (data date, so2 integer, pm10 integer, pm25 integer, no2 integer, co integer, o3 integer, benzene integer);
--.mode csv
--.import ./CSV/MilanoVerziere.csv verziere

select avg(pm10) from senato where data >= '$1/01/01' and data <= '$1/12/31' and pm10 <> " " and pm10 <> "nd";
-- and where instr(pm10, '<') == 0;

--select avg(so2) from senato where data >= '$1/01/01' and data <= '$1/12/31' and so2 <> " " and so2 <> "nd" and where instr(so2, '<') = 0;
--select avg(pm10) from senato where data >= '$1/01/01' and data <= '$1/12/31' and pm10 <> " " and pm10 <> "nd" and where instr(pm10, '<') > 0;
--select avg(pm25) from senato where data >= '$1/01/01' and data <= '$1/12/31' and pm25 <> " " and pm25 <> "nd";
--select avg(no2) from senato where data >= '$1/01/01' and data <= '$1/12/31' and no2 <> " " and no2 <> "nd";
--select avg(co) from senato where data >= '$1/01/01' and data <= '$1/12/31' and co <> " " and co <> "nd";
--select avg(o3) from senato where data >= '$1/01/01' and data <= '$1/12/31' and o3 <> " "  and o3 <> "nd";
--select avg(benzene) from senato where data >= '$1/01/01' and data <= '$1/12/31' and benzene <> " " and benzene <> "nd";

--select * from senato where data >= '$1/01/01' and data <= '$1/12/31';

HERE
#|grep -v nd
#.separator ","
}

################################################################
media(){
# PM10in,PM10out,diff,PM2.5in,PM2.5out
sqlite3 << HERE
create table dati (data1 date, pm10in integer, data2 date, pm10out integer, pm10diff integer, pm25in integer, pm25out integer);
.mode csv
.import $1 dati

--select avg(pm10in),avg(pm10out),avg(pm10diff),avg(pm25in),avg(pm25out) from dati;

select avg(pm10in) from dati where pm10in <> " " and pm10in <> "nd";
select avg(pm10out) from dati where pm10out <> " " and pm10out <> "nd";
select avg(pm10diff) from dati where pm10diff <> " " and pm10diff <> "nd";
select avg(pm25in) from dati where pm25in <> " " and pm25in <> "nd";
select avg(pm25out) from dati where pm25out <> " " and pm25out <> "nd";
--select * from dati where pm10in <> " ";

HERE
}

################################################################
mediaMedie(){
# PM10in,PM10out,diff,PM2.5in,PM2.5out
sqlite3 << HERE
create table dati (data date, pm10in integer, pm10out integer, pm10diff integer, pm25in integer, pm25out integer);
.mode csv
.import medie-mensili.csv dati

--rif: echo Data,PM10in,PM10out,diff,PM2.5in,PM2.5out > medie-mensili.csv

--select avg(pm10in) from dati where pm10in <> " " and pm10in <> "nd";
--select avg(pm10out) from dati where pm10out <> " " and pm10out <> "nd";
select avg(pm10diff) from dati where pm10diff <> " " and pm10diff <> "nd";
--select avg(pm25in) from dati where pm25in <> " " and pm25in <> "nd";
--select avg(pm25out) from dati where pm25out <> " " and pm25out <> "nd";
--select * from dati where pm10in <> " ";

HERE
}


################################################################
plotta(){
gnuplot <<PLOT
# cfr. http://theochem.ki.ku.dk/on_line_docs/gnuplot/gnuplot_16.html

set terminal png size 800,600 large
set output "$FILENAME.png"

set xdata time

set xtics rotate by -90 font "Helvetica,10"
#set xtics autofreq

set timefmt "%Y/%m/%d"
set format x "%Y/%m/%d"
#set xrange ["$DATAINIZIO":"$DATAFINE"]
#set xrange ["2011/01/01":"2014/03/20"]
set xrange ["2008/05/01":]

#lim=$LIMITE*3
#set yrange [0:200]
set ytics 10


##################################################
#moving average
#http://gnuplot.sourceforge.net/demo_cvs/data_feedback.html
#samples(x) = \$0 > 2 ? 3 : (\$0+1)
#avg3(x) = (shift3(x), (back1+back2+back3)/samples(\$0))
#shift3(x) = (back3 = back2, back2 = back1, back1 = x)
# Initialize a running sum
#
#init(x) = (back1 = back2 = back3 = back4 = back5 = sum = 0)
##################################################

#set key right bottom
#set key font ",6"

set datafile missing ' '
set datafile separator ','

#set multiplot

#pioggia(x) = (x > 3 ? 100 : 0)
#limita(x,l) = (x > l ? l : x)

plot '$FILENAME' using 1:5 with lines title 'PM10 difference'

PLOT
}


################################################################
plottaMedieAnnue(){
gnuplot <<PLOT
set terminal png size 800,600 large
set output "MedieAnnue.png"
set datafile missing ' '
set datafile separator ','
plot\
	'medie-annue.csv' using 1:4 with lp title 'average PM10diff (annual)',\
	'medie-annue.csv' using 1:2 with lp title 'average PM10in (annual)',\
	'medie-annue.csv' using 1:3 with lp title 'average PM10out (annual)',\
	0
#	'medie-annue.csv' using 1:5 with lp title 'average PM25in (annual)',\
#	'medie-annue.csv' using 1:6 with lp title 'average PM25out (annual)',\

PLOT
}

################################################################
plottaMedieMensili(){
gnuplot <<PLOT
set terminal png size 800,600 large
set output "MedieMensili.png"

set xdata time
set format x "%Y/%m"
set timefmt "%Y/%m"
set xrange ["2008/05":"2014/03"]

set datafile missing ' '
set datafile separator ','

f(x) = m*x + b

# Data,PM10in,PM10out,Diff,PM2.5in,PM2.5out
plot \
	'medie-mensili.csv' using 1:4  with lines title 'average PM10diff (monthly)',\
	'medie-mensili.csv' using 1:2  with lines title 'PM10in average (monthly)',\
	'medie-mensili.csv' using 1:3  with lines title 'PM10out average (monthly)',\
	0
	#-1.63 title 'diff average'
#	'medie-mensili.csv' using 1:5  with lines title 'PM25in average (monthly)',\
#	'medie-mensili.csv' using 1:6  with lines title 'PM25out average (monthly)',\

PLOT
}

#	fit f(x) 'medie-mensili.csv' using 2:3 via m,b,\

################################################################
### MAIN

FILENAME=datiNoND.csv
ALLDATA=datiAll.csv

dati |tee $ALLDATA|grep -v nd >$FILENAME

echo primo plotta...
plotta

echo Anno\(senato\),PM10,PM2.5,NO2,CO,O3,Benzene > altri.csv
echo Data,PM10in,PM10out,Diff,PM2.5in,PM2.5out > medie-annue.csv
echo Data,PM10in,PM10out,diff,PM2.5in,PM2.5out > medie-mensili.csv

for anno in $(seq 2008 2014)
do
 grep $anno $ALLDATA > ${anno}-dati.csv

# echo prove...
# prove 2008
# prove 2010
# prove 2013
# echo dopo prove...

 (echo -n $anno, ; media ${anno}-dati.csv|tr "\n" ","|rev|cut -c2-|rev) >> medie-annue.csv
 #echo >> medie-annue.csv
 for mese in $(seq -f "%02g" 1 12)
 do
  grep $anno/$mese $ALLDATA > ${anno}-${mese}-dati.csv
  (echo -n $anno/$mese, ; media ${anno}-${mese}-dati.csv|tr "\n" ","|rev|cut -c2-|rev) >> medie-mensili.csv
  #echo >> medie-mensili.csv
 done

 echo -n $anno, >> altri.csv
 altri $anno |tr "\n" "," >> altri.csv
 echo >> altri.csv
done

echo annue...
plottaMedieAnnue

echo mensili...
plottaMedieMensili

echo medie delle diff
mediaMedie

mv *csv CSV
mv *png Grafici
