#!/bin/bash

if
 ! cd $(dirname $0)
then
 exit
fi

export OLDDATA=$PWD/AriaDatiArchive/datacache/
export NEWDATA=$PWD/AriaDatiNew/data/

export GENERATED=$PWD/generated

#####################################

if
 pushd $GENERATED >/dev/null
then
 rm *dati *txt *htm 2>/dev/null
 popd
fi

#./piovositaMilano.sh
#./prepScript.sh  ## non serve piu'...


echo TODO gestire pre 2007

### OLD
find $OLDDATA -type f -name '*gz'|sort -n |while
 read line
do
 #echo @@@ $line @@@
 DIRNAME=$(dirname $line)
 BASENAME=$(basename $line .gz)
 gunzip $line
 ./formatta.sh $DIRNAME/$BASENAME 2>/dev/null
 gzip $DIRNAME/$BASENAME
done

### NEW
find $NEWDATA -type f -name '*gz'|grep -v archive.org |sort -n |while
 read line
do
 #echo @@@ $line @@@
 DIRNAME=$(dirname $line)
 BASENAME=$(basename $line .gz)
 gunzip $line
 AREA=$(echo $line |cut -f2 -d_|cut -f1 -d.)
 ./formatta.sh $DIRNAME/$BASENAME $AREA
 gzip $DIRNAME/$BASENAME
done

./allInOne.sh
./split.sh

detox -r *

./plot.sh



./data.sh
