#!/bin/bash

if
 ! cd CSV
then
 exit
fi

/bin/rm -f *csv

ALL=../allInOne-num-sorted.csv

#NEW=$ALL-numdate
#sed -f ../mesi.sed $ALL.csv > $NEW.csv

CAMPIORIG="Data;Stazione;SO2;PM10;PM2.5;NO2;CO;O3;Benzene"
CAMPI="Data,SO2,PM10,PM2.5,NO2,CO,O3,Benzene"

STAZIONI=$(grep ';' $ALL|cut -f 2 -d ';' |sort|uniq)

echo $STAZIONI > stazioni.csv

for stazione in $STAZIONI
do
 #echo ===
 #echo $stazione
 filename=$(echo $stazione|tr -d ':')
 echo $CAMPI > $filename.csv
 grep $stazione $ALL|cut --complement -f 2 -d';' |sed 's/--/ /g'|sort -n -t "/" --key=1 --key=2 --key=3 |uniq|tr ';' ',' >> $filename.csv
done

detox -r *
